| Disk ARchive 2.5.10 Full featured and portable backup and archiving tool

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | List of all members
libdar::cat_mirage Class Reference
Private

the hard link implementation, cat_mirage is the named entry owned by a directory it points to a common "cat_etoile class" More...

`#include <cat_mirage.hpp>`

Inherits libdar::cat_nomme.

## Public Types
enum | mirage_format { fmt_mirage, fmt_hard_link, fmt_file_etiquette }

## Public Member Functions
| cat_mirage (const std::string &name, cat_etoile *ref)
| cat_mirage (user_interaction &dialog, const smart_pointer< pile_descriptor > &pdesc, const archive_version &reading_ver, saved_status saved, entree_stats &stats, std::map< infinint, cat_etoile * > &corres, compression default_algo, mirage_format fmt, bool lax, bool small)
| cat_mirage (user_interaction &dialog, const smart_pointer< pile_descriptor > &pdesc, const archive_version &reading_ver, saved_status saved, entree_stats &stats, std::map< infinint, cat_etoile * > &corres, compression default_algo, bool lax, bool small)
| cat_mirage (const cat_mirage &ref)
const cat_mirage & | operator= (const cat_mirage &ref)
bool | operator== (const cat_entree &ref) const
| returns true if the two object have the same content
unsigned char | signature () const
| inherited class signature
cat_entree * | clone () const
| a way to copy the exact type of an object even if pointed to by a parent class pointer
cat_inode * | get_inode () const
infinint | get_etiquette () const
infinint | get_etoile_ref_count () const
cat_etoile * | get_etoile () const
bool | is_inode_counted () const
bool | is_inode_wrote () const
bool | is_inode_dumped () const
void | set_inode_counted (bool val) const
void | set_inode_wrote (bool val) const
void | set_inode_dumped (bool val) const
void | post_constructor (const pile_descriptor &pdesc)
bool | is_first_mirage () const
| whether we are the mirage that triggered this hard link creation
virtual void | change_location (const smart_pointer< pile_descriptor > &pdesc)
Public Member Functions inherited from libdar::cat_nomme
| cat_nomme (const std::string &name)
| cat_nomme (const smart_pointer< pile_descriptor > &pdesc, bool small)
bool | operator== (const cat_entree &ref) const
| returns true if the two object have the same content
virtual bool | operator< (const cat_nomme &ref) const
const std::string & | get_name () const
void | change_name (const std::string &x)
bool | same_as (const cat_nomme &ref) const
Public Member Functions inherited from libdar::cat_entree
| cat_entree (const smart_pointer< pile_descriptor > &pdesc, bool small)
| cat_entree ()
| setup an object when read from filesystem
virtual | ~cat_entree () throw (Ebug)
| destructor
bool | operator!= (const cat_entree &ref) const
void | dump (const pile_descriptor &pdesc, bool small) const
void | specific_dump (const pile_descriptor &pdesc, bool small) const
Public Member Functions inherited from libdar::on_pool
void * | operator new (size_t n_byte)
void * | operator new (size_t n_byte, const std::nothrow_t &nothrow_value)
void * | operator new[] (size_t n_byte)
void * | operator new[] (size_t n_byte, const std::nothrow_t &nothrow_value)
void * | operator new (size_t n_byte, memory_pool *p)
void * | operator new[] (size_t n_byte, memory_pool *p)
void | operator delete (void *ptr, memory_pool *p)
| this operator is called by the compiler if an exception is throw from the constructor of the allocated object
void | operator delete[] (void *ptr, memory_pool *p)
| this operator is called by the compiler if an exception is throw from the constructor of the allocated objects
void | operator delete (void *ptr)
| this is the usual delete operator, modified to handle allocated objects allocated on a memory pool or not
void | operator delete[] (void *ptr)
| this is the usual delete[] operator, modified to handle allocated objects allocated on a memory pool or not

## Protected Member Functions
void | inherited_dump (const pile_descriptor &pdesc, bool small) const
| inherited class may overload this method but shall first call the parent's inherited_dump() in the overloaded method
Protected Member Functions inherited from libdar::cat_nomme
void | inherited_dump (const pile_descriptor &pdesc, bool small) const
| inherited class may overload this method but shall first call the parent's inherited_dump() in the overloaded method
Protected Member Functions inherited from libdar::cat_entree
pile * | get_pile () const
| stack used to read object from (nullptr is returned for object created from filesystem)
compressor * | get_compressor_layer () const
escape * | get_escape_layer () const
generic_file * | get_read_cat_layer (bool small) const
| return the adhoc layer in the stack to read from the catalogue objects (except the EA, FSA or Data part)
Protected Member Functions inherited from libdar::on_pool
memory_pool * | get_pool () const
template<class T >
void | meta_new (T *&ptr, size_t num)
template<class T >
void | meta_delete (T *ptr)

## Additional Inherited Members
Static Public Member Functions inherited from libdar::cat_entree
static cat_entree * | read (user_interaction &dialog, memory_pool *pool, const smart_pointer< pile_descriptor > &f, const archive_version &reading_ver, entree_stats &stats, std::map< infinint, cat_etoile * > &corres, compression default_algo, bool lax, bool only_detruit, bool small)

## Detailed Description

the hard link implementation, cat_mirage is the named entry owned by a directory it points to a common "cat_etoile class"

well, a mirage is this fake apparition of water in a desert... I guess you get the picture now... :-)

Definition at line 47 of file cat_mirage.hpp.

## Member Function Documentation

virtual void libdar::cat_mirage::change_location | ( | const smart_pointer< pile_descriptor > & | pdesc | ) |
| inline virtual

for archive merging, will let the object drop EA, FSA and Data to an alternate stack than the one it has been read from

Note
  this is used when cloning an object from a catalogue to provide a merged archive. Such cloned object must point the stack of the archive under construction, so we use this call for that need,
  this is also used when opening a catalogue if an isolated catalogue in place of the internal catalogue of an archive
  this method is virtual for cat_directory to overwrite it and propagate the change to all entries of the directory tree as well for mirage to propagate the change to the hard linked inode

Reimplemented from libdar::cat_entree.

Definition at line 101 of file cat_mirage.hpp.

References libdar::cat_entree::change_location().

void libdar::cat_mirage::post_constructor | ( | const pile_descriptor & | pdesc | ) |
| virtual

let inherited classes build object's data after CRC has been read from file in small read mode

Parameters

  [in] | pdesc | stack to read the data from

Note
  used from cat_entree::read to complete small read
  this method is called by cat_entree::read and mirage::post_constructor only when contructing an object with small set to true

Reimplemented from libdar::cat_entree.

The documentation for this class was generated from the following file:

- cat_mirage.hpp